
/********************** DEFINE **************************************/

#define MANUELL 0
#define AUTO 1
#define BETRACHTER 2
#define ARMLAENGE 3
#define WINKEL 4
#define BEENDEN 5
#define ABBRECHEN 6
#define AUSFUEHREN 7
#define BETRACHTER_GERADE 8
#define FARBE 9
#define BETRACHTER_KREIS 10

#define ALT 0
#define NEU 1

#define ANZAHL_PKTE 154
#define ANZAHL_KANTEN  211
#define ANZAHL_FLAECHEN 100

#define	PI 3.14159265358979323846

#define sqr(x) ((x)*(x))


/* ********************* TYPEDEF *********************************** */

typedef struct {
                double x;
                double y;
                double z;
               } Points; 

typedef struct {
                 short p1;
                 short p2;
               } Kanten;

typedef struct {
                 double max;
                 double min;
                 double akt;
               } Winkel_Daten;

typedef struct {
                Points p1;
                Points p2;
                short sichtbar;
               } Kanten_Punkte_Liste;

typedef struct {
                short p1;
                short p2;
                short p3;
                short p4;
               } Flaechen;

typedef struct { 
                XPoint pp[4];    /* Punkteliste 2D */
                Points p[4];    /* Punkteliste 3D*/
                double zmin;    /* minimaler Wert pro Flaeche */ 
                double nx;
                double ny;
                double nz;
                double C;       /* Koeffizient aus der Ebenen-
                                   gleichung.                   */  
               } Flaechen_Punkte_Liste;

typedef char string[50];

typedef struct {
                double z;
                char teil;
               } sort;

/* ********************* Variablendefinition Roboter ************** */
 Flaechen_Punkte_Liste fpl[ANZAHL_FLAECHEN];

 Points Licht = { -800 , 1500 , 1000 };

 unsigned long FT[7][31];


 double linkl[4] = { 13.5 , 10.0 , 10.0 , 2.5 }; /* Laengen der
                                                    einzelnen Links */

 int wgewicht[6] = { 0 , 30 , 20 , 10 , 10 , 10 }; /* Gewichtung der
                                                    Gelenke fuer die
                                                    automatische Steuer-
                                                    ung.              */
 int power[6] = { 3,3,3,3,3,3 };

 Winkel_Daten Winkel[6] = {{           PI ,          -PI , 0.0 },
                           {  0.523598775 , -3.665191429 , 0.0 },
                           {  0.523598775 , -3.665191429 , 0.0 },
                           {           PI ,          -PI , 0.0 },
                           {         PI/2 ,        -PI/2 , 0.0 },
                           {           PI ,          -PI , 0.0 }};

 Points Gerade[2] = {{ 0.0 , -2.0 , 0.0},
                     { 0.0 ,  0.0 , 0.0 }};
 Kanten Gkl[1] = { 0 , 1 };

 int rpl[14] = { 64,65,94,95,114,115,138,139,140,141,146,147,152,153 };

 Points koorpl[4] = {{0,0,0},
                  {10,0,0},
                  {0,10,0},
                  {0,0,10}}; 
 Kanten koork[3] = {{0,1},
                    {0,2},
                    {0,3}};

 Points pl[ANZAHL_PKTE];
 Points PL[ANZAHL_PKTE]         = {{-25.0 ,   0.0 ,-25.0}, /* Ebene */ /* 0 */
                                   { -8.3 ,   0.0 ,-25.0},
                                   {  8.3 ,   0.0 ,-25.0},
                                   { 25.0 ,   0.0 ,-25.0},
                                   {-25.0 ,   0.0 , -8.3},
                                   { 25.0 ,   0.0 , -8.3},
                                   {-25.0 ,   0.0 ,  8.3},
                                   { 25.0 ,   0.0 ,  8.3},
                                   {-25.0 ,   0.0 , 25.0},
                                   { -8.3 ,   0.0 , 25.0},
                                   {  8.3 ,   0.0 , 25.0}, /* 10 */
                                   { 25.0 ,   0.0 , 25.0},
                                   {  0.0 ,   0.0 , -5.0}, /* Sockel */
                                   { 3.53 ,   0.0 ,-3.53},
                                   {  5.0 ,   0.0 ,  0.0},
                                   { 3.53 ,   0.0 , 3.53},
                                   {  0.0 ,   0.0 ,  5.0},
                                   {-3.53 ,   0.0 , 3.53},
                                   { -5.0 ,   0.0 ,  0.0},
                                   {-3.53 ,   0.0 ,-3.53},
                                   {  0.0 ,   3.0 , -5.0},  /* 20 */
                                   { 3.53 ,   3.0 ,-3.53},
                                   {  5.0 ,   3.0 ,  0.0},
                                   { 3.53 ,   3.0 , 3.53},
                                   {  0.0 ,   3.0 ,  5.0},
                                   {-3.53 ,   3.0 , 3.53},
                                   { -5.0 ,   3.0 ,  0.0},
                                   {-3.53 ,   3.0 ,-3.53},
                                   {  0.0 ,   3.0 , -1.5}, /*Drehscheibe*/
                                   { 1.06 ,   3.0 ,-1.06},
                                   {  1.5 ,   3.0 ,  0.0},  /* 30 */
                                   { 1.06 ,   3.0 , 1.06},
                                   {  0.0 ,   3.0 ,  1.5},
                                   {-1.06 ,   3.0 , 1.06},
                                   { -1.5 ,   3.0 ,  0.0},
                                   {-1.06 ,   3.0 ,-1.06},
                                   {  0.0 ,   3.5 , -1.5}, 
                                   { 1.06 ,   3.5 ,-1.06},
                                   {  1.5 ,   3.5 ,  0.0},
                                   { 1.06 ,   3.5 , 1.06},
                                   {  0.0 ,   3.5 ,  1.5},  /* 40 */
                                   {-1.06 ,   3.5 , 1.06},
                                   { -1.5 ,   3.5 ,  0.0},
                                   {-1.06 ,   3.5 ,-1.06},
                                   { -1.0 ,   3.5 ,  1.0},  /* Link 1 */
                                   { -1.0 ,   3.5 , -1.0},
                                   {  1.0 ,   3.5 , -1.0},
                                   {  1.0 ,   3.5 ,  1.0},
                                   { -1.0 ,  12.5 ,  1.0},
                                   { -1.0 ,  12.5 , -1.0},
                                   {  1.0 ,  12.5 , -1.0},  /* 50 */
                                   {  1.0 ,  12.5 ,  1.0},
                                   {  1.0 ,  12.5 ,  0.5},
                                   { -1.0 ,  12.5 ,  0.5},
                                   { -0.5 ,  14.0 ,  1.0},
                                   {  0.5 ,  14.0 ,  1.0},
                                   {  0.5 ,  14.0 ,  0.5},
                                   { -0.5 ,  14.0 ,  0.5},
                                   {  1.0 ,  12.5 , -0.5},
                                   { -1.0 ,  12.5 , -0.5},
                                   { -0.5 ,  14.0 , -0.5},  /* 60 */
                                   {  0.5 ,  14.0 , -0.5},
                                   {  0.5 ,  14.0 , -1.0},
                                   { -0.5 ,  14.0 , -1.0},
                                   {  0.0 ,  13.5 ,  0.5},  /* Achse 2 */
                                   {  0.0 ,  13.5 , -0.5},
                                   { -0.3 ,  13.0 ,  0.5},  /* Link 2 */
                                   {  1.5 ,  13.0 ,  0.5},
                                   {  1.5 ,  13.0 , -0.5},
                                   { -0.3 ,  13.0 , -0.5},
                                   { -0.3 ,  14.0 ,  0.5},  /* 70 */
                                   {  1.5 ,  14.0 ,  0.5},
                                   {  1.5 ,  14.0 , -0.5},
                                   { -0.3 ,  14.0 , -0.5},
                                   {  1.5 ,  12.5 ,  1.0},
                                   {  1.5 ,  14.5 ,  1.0},
                                   {  1.5 ,  14.5 , -1.0},
                                   {  1.5 ,  12.5 , -1.0},
                                   {  9.0 ,  12.5 ,  1.0},
                                   {  9.0 ,  14.5 ,  1.0},
                                   {  9.0 ,  14.5 , -1.0},  /* 80 */
                                   {  9.0 ,  12.5 , -1.0},
                                   {  9.0 ,  12.5 ,  0.5},
                                   {  9.0 ,  14.5 ,  0.5},
                                   { 10.5 ,  14.0 ,  1.0},
                                   { 10.5 ,  14.0 ,  0.5},
                                   { 10.5 ,  13.0 ,  0.5},
                                   { 10.5 ,  13.0 ,  1.0},
                                   {  9.0 ,  12.5 , -0.5},
                                   {  9.0 ,  14.5 , -0.5},
                                   { 10.5 ,  14.0 , -1.0},  /* 90 */
                                   { 10.5 ,  13.0 , -1.0},
                                   { 10.5 ,  13.0 , -0.5},
                                   { 10.5 ,  14.0 , -0.5},
                                   { 10.0 ,  13.5 ,  0.5},  /* Achse 3 */
                                   { 10.0 ,  13.5 , -0.5},
                                   {  9.5 ,  13.8 ,  0.5}, /* Link 3 */
                                   {  9.5 ,  13.8 , -0.5},
                                   { 10.5 ,  13.8 , -0.5},
                                   { 10.5 ,  13.8 ,  0.5},
                                   { 10.5 ,  11.9 , -0.5},  /* 100 */
                                   { 10.5 ,  11.9 ,  0.5},
                                   {  9.5 ,  11.9 ,  0.5},
                                   {  9.5 ,  11.9 , -0.5},
                                   {  9.0 ,  12.0 ,  1.0},
                                   {  9.0 ,  12.0 , -1.0},
                                   { 11.0 ,  12.0 , -1.0},
                                   { 11.0 ,  12.0 ,  1.0},
                                   { 11.0 ,   4.5 , -1.0},
                                   { 11.0 ,   4.5 ,  1.0},
                                   {  9.0 ,   4.5 ,  1.0},  /* 110 */
                                   {  9.0 ,   4.5 , -1.0},
                                   { 10.0 ,   5.0 ,  0.0},  /* Achse 4 */
                                   { 10.0 ,   4.0 ,  0.0},
                                   { 10.0 ,   3.5 ,  0.5},  /* Achse 5 */
                                   { 10.0 ,   3.5 , -0.5},
                                   { 10.0 ,   4.5 ,  1.0},  /*Gelenk 5 */
                 		   { 10.7 ,   4.2 ,  1.0},
				   { 11.0 ,   3.5 ,  1.0},
                                   { 10.7 ,   2.8 ,  1.0},
                                   { 10.0 ,   2.5 ,  1.0},  /* 120 */
                                   {  9.3 ,   2.8 ,  1.0},
                                   {  9.0 ,   3.5 ,  1.0},
                                   {  9.3 ,   4.2 ,  1.0},
                                   { 10.0 ,   4.5 , -1.0},
                                   { 10.7 ,   4.2 , -1.0},
                                   { 11.0 ,   3.5 , -1.0},
                                   { 10.7 ,   2.8 , -1.0},
                                   { 10.0 ,   2.5 , -1.0},
                                   {  9.3 ,   2.8 , -1.0},
                                   {  9.0 ,   3.5 , -1.0},  /* 130 */
                                   {  9.3 ,   4.2 , -1.0},
                                   { 10.0 ,   3.0 ,  0.0},   /*Achse 6 */
                                   { 10.0 ,   2.0 ,  0.0},
                                   {  9.0 ,   2.5 ,  1.0},   /* Hand */
                                   {  9.0 ,   2.5 , -1.0},
                                   { 11.0 ,   2.5 , -1.0},
                                   { 11.0 ,   2.5 ,  1.0},
                                   { 11.0 ,   2.0 ,  1.0},
                                   {  9.0 ,   2.0 ,  1.0},
                                   {  9.0 ,   2.0 , -1.0},  /* 140 */
                                   { 11.0 ,   2.0 , -1.0},
                                   {  9.0 ,   2.0 ,  1.0},
                                   {  9.0 ,   2.0 , -1.0},
                                   {  9.5 ,   2.0 , -1.0},
                                   {  9.5 ,   2.0 ,  1.0},
                                   {  9.5 ,   0.5 ,  1.0},
                                   {  9.5 ,   0.5 , -1.0},
                                   { 11.0 ,   2.0 , -1.0},
                                   { 11.0 ,   2.0 ,  1.0},
                                   { 10.5 ,   2.0 ,  1.0},  /* 150 */
                                   { 10.5 ,   2.0 , -1.0},
                                   { 10.5 ,   0.5 , -1.0},
                                   { 10.5 ,   0.5 ,  1.0}};  /* 153 */  


Kanten kl[ANZAHL_KANTEN]
               ={{ 0, 3},   /* Ebene */
                 { 0, 8},
                 { 8,11},
                 {11, 3},
                 { 1, 9},
                 { 2,10},
                 { 4, 5},
                 { 6, 7},
                 {12,13},   /* Sockel */
                 {13,14},
                 {14,15},    /*10*/
                 {15,16},
                 {16,17},
                 {17,18},
                 {18,19},
                 {19,12},
                 {20,21},
                 {21,22},
                 {22,23},
                 {23,24},
                 {24,25},   /*20*/
                 {25,26},
                 {26,27},
                 {27,20},
                 {12,20},
                 {13,21},
                 {14,22},
                 {15,23},
                 {16,24},
                 {17,25},
                 {18,26},  /*30*/
                 {19,27},
                 {28,29},    /* Drehscheibe */
                 {29,30},
                 {30,31},
                 {31,32},
                 {32,33},
                 {33,34},
                 {34,35},
                 {35,28},
                 {36,37},   /*40*/
                 {37,38},
                 {38,39},
                 {39,40},
                 {40,41},
                 {41,42},
                 {42,43},
                 {43,36},
                 {28,36},
                 {29,37},
                 {30,38},  /*50*/
                 {31,39},
                 {32,40},
                 {33,41},
                 {34,42},
                 {35,43},
                 {44,45},     /* Link 1 */  /*56*/
                 {45,46},
                 {46,47},
                 {47,44},
                 {44,48},
                 {45,49},
                 {46,50},  
                 {47,51},
                 {48,49},
                 {49,50},
                 {50,51},
                 {51,48},
                 {48,54},
                 {54,55},
                 {55,51},
                 {55,56},
                 {54,57},
                 {52,56},
                 {53,57},
                 {56,57},
                 {52,53},
                 {59,60},
                 {60,63},
                 {63,62},
                 {62,61},
                 {61,60},
                 {49,63},
                 {50,62},
                 {58,61},
                 {58,59},
                 {64,65},  /* Achse 2 */
                 {66,67},  /* Link 2 */
                 {66,69},
                 {66,70},
                 {70,73},
                 {70,71},
                 {71,72},
                 {71,67},
                 {67,68},
                 {68,69},
                 {68,72},
                 {72,73},
                 {74,77},
                 {74,75},
                 {75,76},
                 {76,77},
                 {77,81},
                 {81,80},
                 {80,79},
                 {79,78},
                 {78,81},
                 {74,78},
                 {75,79},
                 {76,80},
                 {79,84},
                 {84,85},
                 {85,86},
                 {86,87},
                 {87,84},
                 {83,85},
                 {83,82},
                 {82,86},
                 {78,87},
                 {88,89},
                 {88,92},
                 {92,91},
                 {92,93},
                 {93,89},
                 {93,90},
                 {90,80},
                 {90,91},
                 {81,91},
                 {94,95},  /* Achse 3 */
                 {96,97},  /* Link 3 */
                 {97,98},
                 {98,99},
                 {99,96},
                 {96,102},
                 {102,101},
                 {101,100},
                 {100,103},
                 {103,102},
                 {103,97},
                 {100,98},
                 {101,99},
                 {104,105},
                 {105,106},
                 {106,107},
                 {107,104},
                 {104,110},
                 {110,111},
                 {111,108},
                 {108,109},
                 {109,110},
                 {111,105},
                 {106,108},
                 {109,107},
                 {112,113},  /*Achse 4 */
                 {114,115},  /*Achse 5 */
                 {116,117},  /* Gelenk 5 */
                 {117,118},
                 {118,119},
                 {119,120},
                 {120,121},
                 {121,122},
                 {122,123},
                 {123,116},
                 {116,124},
                 {124,125},
                 {125,126},
                 {126,127},
                 {127,128},
                 {128,129},
                 {129,130},
                 {130,131},
                 {131,124},
                 {116,124},
                 {117,125},
                 {118,126},
                 {119,127},
                 {120,128},
                 {121,129},
                 {122,130},
                 {123,131},
                 {132,133},  /* Achse 6 */
                 {134,135},  /* Hand */
                 {135,136},
                 {136,137},
                 {137,134},
                 {134,139},
                 {139,140},
                 {140,141},
                 {141,138},
                 {138,139},
                 {140,135},
                 {141,136},
                 {138,137},
                 {142,143},
                 {143,144},
                 {144,145},
                 {145,142},
                 {142,146},
                 {146,145},
                 {146,147},
                 {147,144},
                 {147,143},
                 {150,151},
                 {151,148},
                 {148,149},
                 {149,150},
                 {150,153},
                 {153,149},
                 {153,152},
                 {152,148},
                 {152,151}};    

Flaechen fl[ ANZAHL_FLAECHEN ] = { {  0 ,  8 , 11 ,  3 },  /* EBENE */  /* 0 */
                                   { 12 , 20 , 21 , 13 }, /* Sockel */
                                   { 13 , 21 , 22 , 14 },
                                   { 14 , 22 , 23 , 15 },
                                   { 15 , 23 , 24 , 16 },
                                   { 16 , 24 , 25 , 17 },
                                   { 17 , 25 , 26 , 18 },
                                   { 18 , 26 , 27 , 19 },
                                   { 19 , 27 , 20 , 12 },
                                   { 20 , 27 , 26 , 25 },
                                   { 25 , 24 , 21 , 20 },   /* 10 */
                                   { 21 , 24 , 23 , 22 },
                                   { 28 , 36 , 37 , 29 }, /* Drehscheibe */
                                   { 29 , 37 , 38 , 30 },
                                   { 30 , 38 , 39 , 31 },
                                   { 31 , 39 , 40 , 32 },
                                   { 32 , 40 , 41 , 33 },
                                   { 33 , 41 , 42 , 34 },
                                   { 34 , 42 , 43 , 35 },
                                   { 35 , 43 , 36 , 28 },
                                   { 36 , 43 , 42 , 41 },    /* 20 */
                                   { 36 , 41 , 40 , 37 },
                                   { 37 , 40 , 39 , 38 },
                                   { 44 , 47 , 51 , 48 }, /* Link 1 */
                                   { 47 , 46 , 50 , 51 },
                                   { 45 , 49 , 50 , 46 },
                                   { 44 , 48 , 49 , 45 },
                                   { 48 , 51 , 50 , 49 },
                                   { 48 , 51 , 55 , 54 }, /* Halter 1 Link 1 */
                                   { 51 , 52 , 56 , 55 },
                                   { 52 , 53 , 57 , 56 },   /* 30 */
                                   { 53 , 48 , 54 , 57 },
                                   { 54 , 55 , 56 , 57 },
                                   { 59 , 58 , 61 , 60 }, /* Halter 2 Link1 */
                                   { 58 , 50 , 62 , 61 },
                                   { 49 , 63 , 62 , 50 },
                                   { 49 , 59 , 60 , 63 },
                                   { 60 , 61 , 62 , 63 },
                                   { 66 , 67 , 71 , 70 }, /* Halter 1 Link 2 */
                                   { 70 , 71 , 72 , 73 },
                                   { 68 , 69 , 73 , 72 }, /* 40 */
                                   { 66 , 69 , 68 , 67 },
                                   { 69 , 66 , 70 , 73 },
                                   { 74 , 78 , 79 , 75 }, /* Link 2 */
                                   { 75 , 79 , 80 , 76 },
                                   { 77 , 76 , 80 , 81 },
                                   { 74 , 77 , 81 , 78 },
                                   { 77 , 74 , 75 , 76 },
                                   { 78 , 81 , 80 , 79 },
                                   { 78 , 87 , 84 , 79 }, /* Halter 2 Link 2 */
                                   { 78 , 82 , 86 , 87 }, /* 50 */
                                   { 82 , 83 , 85 , 86 },
                                   { 83 , 79 , 84 , 85 },
                                   { 84 , 87 , 86 , 85 },
                                   { 89 , 88 , 92 , 93 }, /* Halter 3 Link 2 */
                                   { 88 , 81 , 91 , 92 },
                                   { 81 , 80 , 90 , 91 },
                                   { 80 , 89 , 93 , 90 },
                                   { 93 , 92 , 91 , 90 },
                                   {102 ,101 , 99 , 96 }, /* Halter 1 Link 3 */
                                   {101 ,100 , 98 , 99 }, /* 60 */
                                   {103 , 97 , 98 ,100 },
                                   {103 ,102 , 96 , 97 },
                                   { 96 , 99 , 98 , 97 },
                                   {110 ,109 ,107 ,104 }, /* Link 3 */
                                   {109 ,108 ,106 ,107 },
                                   {111 ,105 ,106 ,108 },
                                   {111 ,110 ,104 ,105 },
                                   {104 ,107 ,106 ,105 },
                                   {110 ,111 ,108 ,109 },
                                   {116 ,123 ,122 ,121 }, /* Gelenk */ /* 70 */
                                   {116 ,121 ,120 ,117 },
                                   {117 ,120 ,119 ,118 },
                                   {116 ,117 ,125 ,124 },
                                   {117 ,118 ,126 ,125 },
                                   {118 ,119 ,127 ,126 },
                                   {119 ,120 ,128 ,127 },
                                   {120 ,121 ,129 ,128 },
                                   {121 ,122 ,130 ,129 },
                                   {122 ,123 ,131 ,130 },
                                   {123 ,116 ,124 ,131 }, /* 80 */
                                   {124 ,129 ,130 ,131 },
                                   {124 ,125 ,128 ,129 },
                                   {125 ,126 ,127 ,128 },
                                   {139 ,138 ,137 ,134 },/* Handgundflaeche */
                                   {138 ,141 ,136 ,137 },
                                   {140 ,135 ,136 ,141 },
                                   {140 ,139 ,134 ,135 },
                                   {134 ,137 ,136 ,135 },
                                   {139 ,140 ,141 ,138 },
                                   {146 ,145 ,142 ,146 },/*Handgreifer 1   90*/
                                   {146 ,147 ,144 ,145 },
                                   {142 ,145 ,144 ,143 },
                                   {143 ,144 ,147 ,147 },
                                   {147 ,146 ,142 ,143 },
                                   {153 ,149 ,150 ,153 },/*Handgreifer 2 */
                                   {153 ,152 ,148 ,149 },
                                   {151 ,148 ,152 ,152 },
                                   {152 ,153 ,150 ,151 },
                                   {150 ,149 ,148 ,151 }}; 

/* ********************* Variablendefinition X - Window *********** */

XEvent myevent;
XSizeHints graphhint,
           helphint,
           texthint;
XColor color;
Display *mydisplay;
int myscreen;
Window errorwin,
       Graphdwin,
       Bregelwin[3],
       Ausgabefenster,
       graphwin,
       textwin,
       bwin[10],
       fwin[7],
       hwin[7],
       regelwin,
       helpwin,
       dwin;
Pixmap pixmap;
GC graphgc,
   textgc,
   dgc,
   titelgc,
   bgc[9],
   fgc[7],
   hgc[7],
   helpgc;
Colormap cmap,cmaphilf;
KeySym key;
Font font[3];
unsigned int depth;
unsigned int foreground,
             background,
             plane,           /* Farbe der Grundflaeche */
             graphbg,         /* Backgroundcolor des Grafikfensters */ 
             farbe[8];        /* Link-Farbe */
Cursor curs;
XWMHints mywmhints;
int x_regler = 25;
int Bregler[3] = { 225 , 270 , 360 };
    
FILE *frobo, *fviewer;
Points BListe[361];

short f_Z_B = 0,
      f_Z_R = 0;
int akt = 0;
int errvariable = 0;
